//  created:    2019/03/12
//  filename:   VrpnLite.h
//
//  author:     Guillaume Sanahuja
//              Copyright Heudiasyc UMR UTC/CNRS 7253
//
//  version:    $Id: $
//
//  purpose:    vrpnlite, to forward it to bth for exemple
//              usefull to reduce vrpn frame size
//
/*********************************************************************/

#ifndef VRPNLITE_H
#define VRPNLITE_H

#include <string>
#include <Thread.h>

namespace flair {
  namespace core {
    class UdpSocket;
  }
	namespace sensor {
		class VrpnClient;
		class VrpnObject;
	}
}

class VrpnLite: public flair::core::Thread {
  public:
      VrpnLite(std::string clientAddress,std::string serveurAddress);
      ~VrpnLite();

private:
      void Run(void);
      flair::sensor::VrpnClient* vrpnclient;
      std::vector<flair::sensor::VrpnObject*> vrpnobjects;
      flair::core::UdpSocket* dataSocket;
      void SendObject(const flair::sensor::VrpnObject* vrpnobject,uint8_t id) const;
      
};

#endif // VRPNLITE_H
